`cluster_subset_peaks` <-
function(clusters, peaks_of_interest=c(), 
                                 min_peaks_per_cluster=1) {

  subset_clusters <- list();
  clust_means <- c();
  for (i in 1:length(clusters)) {
    cluster <- clusters[[i]];
    if (nrow(cluster) >= min_peaks_per_cluster) {
      subset_clusters[[length(subset_clusters)+1]] <- clusters[[i]];
      clust_means <- c(clust_means, mean(cluster$mz, na.rm=TRUE));
    }
  }
  clusters <- subset_clusters;

  if (length(peaks_of_interest) > 0) {
    subset_clusters <- list();
    for (i in peaks_of_interest) {
      hit <- which.min(abs(clust_means - i))
      if (length(hit) == 1) {
        subset_clusters[[length(subset_clusters)+1]] <- clusters[[hit]];
      }
    }
    clusters <- unique(subset_clusters);
  }
  
  clusters
}

