`filter_clusters` <-
function(cluster_list, peaks_of_interest=c(), 
                            min_peaks_per_cluster=1) {

  if (length(cluster_list) > 0) {
    print("Selecting maximal peaks per cluster")
    cluster_list <- cluster_max_peaks(cluster_list)
  }

  if (length(cluster_list) > 0) {
    print("Extracting peak subsets per cluster (if needed)")
    cluster_list <- cluster_subset_peaks(cluster_list, 
                    peaks_of_interest=peaks_of_interest, 
                    min_peaks_per_cluster=min_peaks_per_cluster)
  }

  if (length(cluster_list) > 0) {
    print("Removing clusters with constant peak heights")
    cluster_list <- cluster_constant_clusters(cluster_list);
  }

  cluster_list
}

