`filter_peaks` <-
function(data, peak_indexes, offset="mean", deviation="sd", scale="local", smooth=TRUE, 
                         quantile=NULL, sn_ratio=5, min_mz=min(mz_values, na.rm=TRUE), max_mz=max(data$mz, na.rm=TRUE), perc_width=0.3) {
  num.samples <- ncol(data$mz);

  filtered_peak_indexes <- list()
  for (i in 1:num.samples) {
    print(paste("Filtering peaks in", colnames(data$mz)[i]))

    mz_values    <- data$mz[,i];
    intensities  <- data$int[,i];

    filtered_peak_indexes[[i]] <- filter_peaks_in_spectrum(mz_values, intensities, 
                                    peak_indexes[[i]], offset=offset, deviation=deviation, 
                                    scale=scale, smooth=smooth, quantile=quantile, sn_ratio=sn_ratio, 
                                    min_mz=min_mz, max_mz=max_mz, perc_width=perc_width)
  }

  filtered_peak_indexes
}

