`get_peak_data` <-
function(data, peak_indexes) {
  num.samples <- ncol(data$mz);

  peak_data <- c()
  for (i in 1:num.samples) {
    mz_values   <- data$mz[,i];
    intensities <- data$int[,i];

    h <- peak_indexes[[i]]

    if (i == 1) {
      peak_data <- matrix(c(mz_values[h], intensities[h], rep(i, length(h))), ncol=3);
    } else {
      peak_data <- rbind(peak_data, matrix(c(mz_values[h], intensities[h], 
                                             rep(i, length(h))), ncol=3))
    }
  }
  peak_data <- data.frame(peak_data)
  names(peak_data) <- c("mz", "int", "spectrum")

  peak_data
}

