`get_peaks_in_spectrum` <-
function(intensities, negative=FALSE, iter=1) {
  if (negative == TRUE) { intensities <- -intensities; }

  peak_indexes <- 1:length(intensities);
  for (i in 1:iter) {
    slopeSign <- diff(intensities)>0;        # Find sign of slopes (incr. if first deriv > 0)
    slopeSignChange <- diff(slopeSign)<0;    # Find changes in slope sign (from incr. to decr.)
    h <- which(slopeSignChange == TRUE) + 1; # Select positions with changes in slope sign, i.e. peaks
    if (!negative) 
      h <- h[which(intensities[h] > 0)];

    peak_indexes <- peak_indexes[h];
    intensities <- intensities[h];
  }

  return(peak_indexes)
}

