`get_pvals_kruskal` <-
function(cluster_data, classlabels) {
  max_cluster <- length(cluster_data)
  pvals <- c();

  for (i in 1:max_cluster) {
    m <- data.frame(classes=classlabels, 
                    data=cluster_data[[i]][, "int"]);
    pval <- kruskal.test(data ~ classes, data=m)$p.value
    pvals <- c(pvals, pval)

    #print(paste("Cluster", i, ":", round(pval, 3)))
  }
  print(paste("Overall pval (mean):", round(mean(pvals, na.rm=TRUE), 3)))
  print(paste("Overall pval (median):", round(median(pvals, na.rm=TRUE), 3)))

  pvals
}

