`merge_clusters` <-
function(found_clusters, data) {
  chain_list <- list()

  for(i in unique(found_clusters)) {
    clust_indexes <- which(found_clusters == i)
    clust_data <- data[clust_indexes]
    num_chains <- length(chain_list)
    if (i == 1) {
      chain_list[[1]] <- cbind(clust_indexes, i)
    } else {
      clus_diff <- min(clust_data) - max(data[chain_list[[num_chains]][,1]], na.rm=TRUE)
      if (clus_diff < diff(range(clust_data))) {
        chain_list[[num_chains]] <- rbind(chain_list[[num_chains]], cbind(clust_indexes, i))
      } else {
        chain_list[[num_chains+1]] <- cbind(clust_indexes, i)
      }
    }
  }

  merged_found_clusters <- c()
  clust_num <- 0
  for(j in 1:length(chain_list)) {
    orig_clusts <- unique(chain_list[[j]][,2])
    num_orig_clusts <- length(orig_clusts)

    # Data for prospective cluster(s) 
    prosp_clust_indexes <- chain_list[[j]][,1]
    prosp_clust_data    <- data[prosp_clust_indexes]

    print(paste("Merging chain", j))
    if (num_orig_clusts == 1) {
      clust_num <- clust_num + 1
      merged_found_clusters <- c(merged_found_clusters, rep(clust_num, nrow(chain_list[[j]])))
    } else {
      sil.max <- -Inf
      clust.max <- 0
      k.max <- 0
      for (k in 2:num_orig_clusts) {
        print(paste("Trying", k, "clusters out of original", num_orig_clusts))
        clust <- pam(prosp_clust_data, k=k)$clustering
        sil <- silhouette(clust, dist(prosp_clust_data))
        if (summary(sil)$avg.width > sil.max) {
          sil.max <- summary(sil)$avg.width
          clust.max <- clust
          k.max <- k
        }
      }
      print(paste("Best k found for chain", j, ":", k.max))

      if (k.max != num_orig_clusts) {
        print(paste("Re-arranging clusters", min(orig_clusts), "-", max(orig_clusts),  
                    "to clusters", clust_num+1, "-", clust_num+k.max))
      }
      merged_found_clusters <- c(merged_found_clusters, clust_num+clust.max)
      clust_num <- clust_num + max(clust.max)
    }
  }

  merged_found_clusters
}

