`merge_data` <-
function(data, spectra_sets) {
  new_data      <- list();
  new_data$mz   <- NULL;
  new_data$int  <- NULL;
  new_data$conf <- data$conf;
  new_c_labels    <- c();
  new_s_labels    <- c();

  for (i in unique(spectra_sets)) {
    if (length(which(spectra_sets == i)) > 1) { 
      new_mz  <- apply(data$mz[,which(spectra_sets == i)], 1, mean);
      new_int <- apply(data$int[,which(spectra_sets == i)], 1, sum);
    } else {
      new_mz  <- data$mz[,which(spectra_sets == i)];
      new_int <- data$int[,which(spectra_sets == i)];
    }

    new_data$mz  <- cbind(new_data$mz,  new_mz);
    new_data$int <- cbind(new_data$int, new_int);
    new_c_labels <- c(new_c_labels, paste(unique(data$conf$classlabels[which(spectra_sets == i)]), collapse="_"))
    new_s_labels <- c(new_s_labels, paste(unique(colnames(data$mz)[which(spectra_sets == i)]), collapse="_"))
  }

  new_data$mz  <- data.frame(new_data$mz);
  new_data$int <- data.frame(new_data$int);
  colnames(new_data$mz)     <- new_s_labels;
  colnames(new_data$int)    <- new_s_labels;
  new_data$conf$classlabels <- new_c_labels;

  new_data
}

