\name{MASDA-package}
\alias{MASDA-package}
\alias{MASDA}
\docType{package}
\title{
MASDA: R package for Mass Spectrometry Data Analysis.
}
\description{
The package has been developed with SELDI-TOF-MS data in mind. 
It should however be useful for other types of mass spectrometers as well, 
MALDI-TOF-MS in particular.
}
\details{
\tabular{ll}{
Package: \tab MASDA\cr
Type: \tab Package\cr
Version: \tab 0.5\cr
Date: \tab 2007-08-29\cr
License: \tab GPL version 2 or newer\cr
}
The package includes routines for loading mass spectrometry data from CSV files,
doing baseline correction and normalisation, peak detection and filtering,
peak clustering across spectra, peak filtering and some visualisation of results.
}
\author{
Wouter Meuleman <w.meuleman@tudelft.nl>
}
\references{
}
\keyword{ package }
\seealso{
}
\examples{

data(MASDA_data_raw)

data_base <- baseline_estimate(MASDA_data_raw, method="PROcess")
data_norm <- normalisation(data_base)

peak_indexes <- get_peaks(data_norm);
peak_indexes <- filter_peaks(data_norm, peak_indexes, min_mz=2000);
peak_data    <- get_peak_data(data_norm, peak_indexes);
cluster_list <- get_clusters(peak_data);
cluster_list <- filter_clusters(cluster_list);
cluster_data <- get_cluster_data(cluster_list, data_norm);

}
